# file

将接收到的数据以文件的形式写入到本地。

!!! example

    ```yaml
    sink:
      type: file
      workerCount: 1024
      baseDirs:
        - /data0
        - /data1
        - /data2
      dirHashKey: ${namespace}-${deployName}
      filename: /${namespace}/${deployName}/${podName}/${filename}
      maxSize: 500
      maxAge: 7
      maxBackups: 50
      compress: true
    ```

## workerCount
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| workerCount | int  |    非必填    |   1  | 写文件的并发数 |

## baseDirs
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| baseDirs | string数组  |    非必填    |     | 文件的基础目录，可以按某个key做哈希，然后存储到对应的基础目录上 |

## dirHashKey
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| dirHashKey | string  |    非必填    |     | 按指定Key做哈希，支持变量 |

## filename
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| filename | string  |    必填    |     | 文件名，支持变量 |

## maxSize
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| maxSize | int  |    非必填    |   1  | 文件大小，单位为MiB |

## maxAge
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| maxAge | int  |    非必填    |     | 旧文件保留天数，单位「天」，默认不删除 |

## maxBackups
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| maxBackups | int  |    非必填    |   1  | 最大保留的备份文件数，默认不删除（如果maxAge配置了，那么文件依旧会被删除） |

## localTime
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| localTime | bool  |    非必填    |   false  | 是否用本地时间格式化备份文件，默认使用UTC时间 |

## compress
|    `字段`   |    `类型`    |  `是否必填`  |  `默认值`  |  `含义`  |
| ---------- | ----------- | ----------- | --------- | -------- |
| compress | bool  |    非必填    |   false  | 是否压缩，使用gzip，默认不压缩 |
