# 用户指南
在本「用户指南」部分，我们主要介绍Loggie的主要功能和特性，同时展示在各种不同的场景下，如何使用Loggie满足各类需求。  

如果希望查询具体组件的使用与配置方式，请戳「[组件配置](../reference/index.md)」。

## 落地一套日志系统会遇到哪些问题？
在企业中，我们需要怎么去构建一套完整的日志系统？如何根据实际情况选型，其中又会碰到哪些问题？  
在不同的业务类型、不同的使用场景、不同的日志规模下，我们可以采用哪些日志系统架构？

请看「[企业实战](enterprise-practice/architecture-and-evolution.md)」。

在我们对落地一套功能完善、架构完整的日志系统有初步了解后，想要知道：

## 为什么Loggie能解决这些问题？
市面上开源的日志采集Agent已经很多了，我们为什么又选择研发Loggie呢？  
Loggie的诞生是为了解决什么问题呢？  
Loggie和其他的开源日志Agent区别是什么？  

请看「[架构与特性](architecture/background.md)」。

## 如何使用Loggie解决这些问题？
如何在Kubernetes集群下使用Loggie？  
请看「[Kubernetes](use-in-kubernetes/general-usage.md)」。  

如何配置各种不同的日志架构？如何接入现有的服务？如何配置日志的处理和切分？Loggie还提供了哪些有用又好用的功能？  
请看「[最佳实践](best-practice/log-enrich.md)」。  

如何配置整体的监控和报警，保证Loggie正常运行？如何监控是否采集到ERROR日志？  
请看「[监控报警](monitor/loggie-monitor.md)」。  
